const { ipcMain } = require('electron');
const puppeteer = require('puppeteer');
const { smartLoop } = require('./navigator');
const { startExchange } = require('../renderer/app/services/exchangeService');

ipcMain.handle('getAppVersion', async () => {
  return app.getVersion();
});

 

ipcMain.handle('run-test-tools', async (event, urls) => {
  try {
    console.log('[Main] Received URLs:', urls);
    for (const site of urls) {
      const browser = await puppeteer.launch({ headless: false, /* config */ });
      const page = await browser.newPage();
      await smartLoop(page, site);
      await browser.close();
    }
    return { success: true, data: 'Tools ran successfully' };
  } catch (error) {
    console.error('[Main] Error:', error);
    return { success: false, error: error.message };
  }
});

 


ipcMain.handle('start-exchange', async (event, urls) => {
  try {
    await startExchange(urls);
    return { success: true };
  } catch (err) {
    console.error('Error starting exchange:', err);
    throw err;
  }
});

//   try {
//     for (const site of urls) {
//       const browser = await puppeteer.launch({ headless: false, /* config */ });
//       const page = await browser.newPage();
//       await smartLoop(page, site);
//       await browser.close();
//     }
//     return 'Run Test Completed!';
//   } catch (err) {
//     console.error('Error:', err);
//     return 'Run Test Failed!';
//   }
// });


// // IPC handler 
// ipcMain.handle('run-test-tools', async (event, urls) => {
//   try {
//     for (const site of urls) {
//       console.log('Processing:', site.url);

//       const loopCount = site.loopCount || 1;

//       const win = new BrowserWindow({
//         width: 1200,
//         height: 800,
//         show: true,
//         autoHideMenuBar: true,
//         menuBarVisible: false,
//         webPreferences: {
//           nodeIntegration: false,
//           contextIsolation: true,
//         },
//       });

//       const userAgent = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/122.0.0.0 Safari/537.36';
//       win.webContents.setUserAgent(userAgent);

//       for (let i = 0; i < loopCount; i++) {
//         console.log(`🔄 Loop ${i+1}/${loopCount}`);

//         // 1. Visit URL
//         await win.loadURL(site.url, { userAgent });
//         await wait(3000);  // Stabilize
//         console.log('📄 Loaded main page.');

//         // 2. Delay
//         if (site.delay) {
//           console.log(`⏳ Waiting delay: ${site.delay}ms`);
//           await wait(site.delay);
//         }
 
//         // 3. Scroll to bottom
//         if (site.scrollToBottom) {
//           console.log('📜 Starting smart human scroll...');
//           await smartHumanScroll(win);  
//           console.log('✅ Smart human scroll done.');
//         } 

//         // 4. Delay after scroll
//         if (site.delay) {
//           console.log(`⏳ Waiting delay after scroll: ${site.delay}ms`);
//           await wait(site.delay);
//         }

//         // 5. Click Nav
//         if (site.clickNav) {
//           console.log('🔗 Finding internal links...');
//           const randomLink = await win.webContents.executeJavaScript(`
//             (function() {
//               const domain = location.hostname;
//               const anchors = Array.from(document.querySelectorAll('a'));
//               const links = anchors.map(a => a.href).filter(href => {
//                 try {
//                   return new URL(href).hostname === domain;
//                 } catch (e) { return false; }
//               });
//               if (links.length > 0) {
//                 return links[Math.floor(Math.random() * links.length)];
//               }
//               return null;
//             })();
//           `);

//           if (randomLink) {
//             console.log('➡️ Clicking:', randomLink);
//             await win.loadURL(randomLink, { userAgent });
//             await wait(3000); // stabilize setelah klik link
//           } else {
//             console.log('❌ No internal links found.');
//           }
//         }

//         // 6. Sleep after clickNav
//         if (site.sleepTime) {
//           console.log(`⏳ Sleeping after clickNav: ${site.sleepTime}ms`);
//           await wait(site.sleepTime);
//         }

//         // 7. Click Selector
//         if (site.clickSelector) {
//           console.log('🖱️ Trying clickSelector:', site.clickSelector);
//           try {
//             await win.webContents.executeJavaScript(`
//               (function() {
//                 const el = document.querySelector('${site.clickSelector}');
//                 if (el) el.click();
//               })();
//             `);
//             await wait(500);
//           } catch (error) {
//             console.error('❌ clickSelector failed:', site.clickSelector);
//           }
//         }

//         console.log(`✅ Finished loop: ${i+1}/${loopCount}`);
//       }

//       await win.close();
//     }

//     return 'Run Test Tools completed!';
//   } catch (error) {
//     console.error('Error in run-test-tools:', error);
//     return 'Run Test Tools failed.';
//   }
// });

// ipcMain.handle('run-test-tools', async (event, urls) => {
//   try {
//     for (const site of urls) {
//       console.log('Processing:', site.url);

//       const loopCount = site.loopCount || 1;

//       const win = new BrowserWindow({
//         width: 1200,
//         height: 800,
//         show: true,
//         autoHideMenuBar: true,
//         menuBarVisible: false,
//         webPreferences: {
//           nodeIntegration: false,
//           contextIsolation: true,
//         },
//       });

//       const userAgent = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/122.0.0.0 Safari/537.36';
//       win.webContents.setUserAgent(userAgent);

//       for (let i = 0; i < loopCount; i++) {
//         console.log(`🔄 Loop ${i + 1}/${loopCount}`);

//         // 1. Visit URL
//         await win.loadURL(site.url, { userAgent });
//         await wait(3000);  // Stabilize
//         console.log('📄 Loaded main page.');

//         // 2. Random Delay after load
//         if (site.delayMin && site.delayMax) {
//           const randomDelay = Math.floor(Math.random() * (site.delayMax - site.delayMin + 1)) + site.delayMin;
//           console.log(`⏳ Random delay: ${randomDelay}s`);
//           await wait(randomDelay * 1000);
//         }

//         // 3. Scroll to bottom
//         if (site.scroll) { // Bukan scrollToBottom lagi
//           console.log('📜 Starting smart human scroll...');
//           await SmartHumanScroll(win);
//           console.log('✅ Smart human scroll done.');
//         }

//         // 4. Random Delay after scroll
//         if (site.delayMin && site.delayMax) {
//           const randomDelayAfterScroll = Math.floor(Math.random() * (site.delayMax - site.delayMin + 1)) + site.delayMin;
//           console.log(`⏳ Random delay after scroll: ${randomDelayAfterScroll}s`);
//           await wait(randomDelayAfterScroll * 1000);
//         }

//         // 5. Click Nav
//         if (site.clickNav) {
//           console.log('🔗 Finding internal links...');
//           const randomLink = await win.webContents.executeJavaScript(`
//             (function() {
//               const domain = location.hostname;
//               const anchors = Array.from(document.querySelectorAll('a'));
//               const links = anchors.map(a => a.href).filter(href => {
//                 try {
//                   return new URL(href).hostname === domain;
//                 } catch (e) { return false; }
//               });
//               if (links.length > 0) {
//                 return links[Math.floor(Math.random() * links.length)];
//               }
//               return null;
//             })();
//           `);

//           if (randomLink) {
//             console.log('➡️ Clicking:', randomLink);
//             await win.loadURL(randomLink, { userAgent });
//             await wait(3000);
//           } else {
//             console.log('❌ No internal links found.');
//           }
//         }

//         // 6. Random Sleep after clickNav
//         if (site.sleepMin && site.sleepMax) {
//           const randomSleep = Math.floor(Math.random() * (site.sleepMax - site.sleepMin + 1)) + site.sleepMin;
//           console.log(`😴 Random sleep after clickNav: ${randomSleep}s`);
//           await wait(randomSleep * 1000);
//         }

//         // 7. Click Selector (Optional)
//         if (site.clickSelector) {
//           console.log('🖱️ Trying clickSelector:', site.clickSelector);
//           try {
//             await win.webContents.executeJavaScript(`
//               (function() {
//                 const el = document.querySelector('${site.clickSelector}');
//                 if (el) el.click();
//               })();
//             `);
//             await wait(500);
//           } catch (error) {
//             console.error('❌ clickSelector failed:', site.clickSelector);
//           }
//         }

//         console.log(`✅ Finished loop: ${i + 1}/${loopCount}`);
//       }

//       await win.close();
//     }

//     return 'Run Test Tools completed!';
//   } catch (error) {
//     console.error('Error in run-test-tools:', error);
//     return 'Run Test Tools failed.';
//   }
// });

 
// async function wait(ms) {
//   return new Promise(resolve => setTimeout(resolve, ms));
// }

// async function SmartHumanScroll(win) {
//   await win.webContents.executeJavaScript(`
//     new Promise(async (resolve) => {
//       function findScrollableElement() {
//         const candidates = [document.scrollingElement || document.documentElement, document.body];
//         const customScrollables = Array.from(document.querySelectorAll('*')).filter(el => {
//           const style = window.getComputedStyle(el);
//           return (style.overflowY === 'auto' || style.overflowY === 'scroll') && el.scrollHeight > el.clientHeight + 100;
//         });
//         return customScrollables[0] || candidates.find(el => el.scrollHeight > el.clientHeight + 100);
//       }

//       const scrollTarget = findScrollableElement();
//       if (!scrollTarget) {
//         console.log('❌ No scrollable element found.');
//         resolve();
//         return;
//       }

//       console.log('📜 Super smart scroll starting...');

//       const totalHeight = scrollTarget.scrollHeight;
//       const viewHeight = scrollTarget.clientHeight || window.innerHeight;
//       let scrolled = 0;
//       let scrollCounter = 0;
//       let fullPauseDone = false;

//       async function step() {
//         return new Promise(async (stepDone) => {
//           const distance = Math.floor(Math.random() * 20) + 10; // Scroll 10-30px
//           const randomPauseChance = Math.random();
//           const randomReverseChance = Math.random();
          
//           // Kadang scroll mundur
//           if (randomReverseChance < 0.05 && scrolled > 0) {
//             const upDistance = Math.floor(Math.random() * 30) + 20; // 20-50px ke atas
//             if (scrollTarget === window) {
//               window.scrollBy(0, -upDistance);
//             } else {
//               scrollTarget.scrollTop -= upDistance;
//             }
//             scrolled = Math.max(scrolled - upDistance, 0);
//             console.log('⬆️ Scroll balik:', upDistance, 'px');
//           } else {
//             if (scrollTarget === window) {
//               window.scrollBy(0, distance);
//             } else {
//               scrollTarget.scrollTop += distance;
//             }
//             scrolled += distance;
//             console.log('⬇️ Scroll turun:', distance, 'px');
//           }

//           scrollCounter++;

//           // Setelah 5-8 langkah, pause baca singkat
//           if (scrollCounter % (Math.floor(Math.random() * 3) + 5) === 0) {
//             const pauseShort = Math.floor(Math.random() * 2000) + 1000; // 1s-3s baca
//             console.log('⏸ Pause membaca sebentar:', pauseShort, 'ms');
//             await new Promise(r => setTimeout(r, pauseShort));
//           }

//           // Di tengah-tengah halaman, kadang pause panjang
//           if (!fullPauseDone && scrolled > (totalHeight / 2)) {
//             if (Math.random() < 0.3) { // 30% chance pause lama
//               const pauseLong = Math.floor(Math.random() * 4000) + 3000; // 3s-7s
//               console.log('⏸ Pause membaca lama di tengah:', pauseLong, 'ms');
//               await new Promise(r => setTimeout(r, pauseLong));
//               fullPauseDone = true;
//             }
//           }

//           const delay = Math.floor(Math.random() * 400) + 300; // Delay 300-700ms
//           setTimeout(stepDone, delay);
//         });
//       }

//       async function scrollLoop() {
//         while (scrolled < totalHeight - viewHeight - 100) {
//           await step();
//         }
//         console.log('✅ Super Smart Scroll selesai.');
//         resolve();
//       }

//       if (document.readyState === 'complete') {
//         scrollLoop();
//       } else {
//         window.addEventListener('load', scrollLoop);
//       }
//     });
//   `);
// } 