const { contextBridge, ipcRenderer } = require('electron');

// Mengekspos API untuk renderer (React)
contextBridge.exposeInMainWorld('electronAPI', {
  // Kirim data ke main process
  send: (channel, data) => ipcRenderer.send(channel, data),

  // Fungsi untuk menjalankan test tools menggunakan Puppeteer
  runTestTools: (urls) => ipcRenderer.invoke('run-test-tools', urls),
  startExchange: (data) => ipcRenderer.invoke('start-exchange', data),

  // Menerima pesan dari main process (untuk menerima event dan data)
  receive: (channel, func) => {
    ipcRenderer.on(channel, (event, ...args) => func(...args));
  }
});
