export default function Modal({ children, onClose }) {
  return React.createElement(
    'div',
    {
      style: {
        position: 'fixed',
        top: 0,
        left: 0,
        right: 0,
        bottom: 0,
        backgroundColor: 'rgba(0,0,0,0.5)',
        display: 'flex',
        justifyContent: 'center',
        alignItems: 'center',
        zIndex: 1000,
      },
      onClick: onClose,
    },
    React.createElement(
      'div',
      {
        style: {
          backgroundColor: '#fff',
          padding: '30px',
          borderRadius: '8px',
          position: 'relative',
          minWidth: '400px',
          boxShadow: '0 0 10px rgba(0,0,0,0.3)',
        },
        onClick: (e) => e.stopPropagation(), // biar klik dalam modal gak nutup
      },
      React.createElement(
        'button',
        {
          onClick: onClose,
          style: {
            position: 'absolute',
            top: '10px',
            right: '10px',
            background: 'none',
            border: 'none',
            fontSize: '20px',
            cursor: 'pointer',
          }
        },
        '×'
      ),
      children
    )
  );
}
