export default function StartStopModal({ siteData, onAction, onCancel }) {
  const isActive = siteData.status === 'Active';
  const targetStatus = isActive ? 'Stopped' : 'Active';

  function handleConfirm() {
    onAction(siteData.id, targetStatus);
  }

  return React.createElement(
    'div',
    { style: formStyle },
    React.createElement('h2', { style: titleStyle }, isActive ? '🛑 Stop Site' : '▶️ Start Site'),

    React.createElement('p', {}, `Apakah kamu yakin ingin ${isActive ? 'menghentikan' : 'memulai'} site ini?`),
    React.createElement('p', { style: { fontWeight: 'bold' } }, siteData.url),

    React.createElement('div', { style: buttonGroup },
      React.createElement('button', { onClick: handleConfirm, style: saveButton }, isActive ? 'Stop' : 'Start'),
      React.createElement('button', { onClick: onCancel, style: cancelButton }, 'Cancel')
    )
  );
}

// === Styles ===
const formStyle = { display: 'flex', flexDirection: 'column', gap: '20px', alignItems: 'center' };
const titleStyle = { marginBottom: '10px', textAlign: 'center' };
const buttonGroup = { display: 'flex', gap: '20px', justifyContent: 'center' };
const saveButton = { backgroundColor: '#007bff', color: 'white', padding: '10px 20px', border: 'none', borderRadius: '5px', cursor: 'pointer' };
const cancelButton = { backgroundColor: '#dc3545', color: 'white', padding: '10px 20px', border: 'none', borderRadius: '5px', cursor: 'pointer' };
