// Semua aksi browser: scroll, klik, move mouse

function sleep(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
  }
  
  function randomBetween(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
  }
  
  export const actions = {
    async scroll(threadId, minScrolls, maxScrolls, intervalMin, intervalMax) {
      console.log(`[Thread ${threadId}] 📜 Starting smooth scroll...`);
  
      for (let i = 0; i < randomBetween(minScrolls, maxScrolls); i++) {
        window.scrollBy(0, randomBetween(100, 300));
        await sleep(randomBetween(intervalMin, intervalMax));
      }
  
      console.log(`[Thread ${threadId}] 📜 Finished smooth scroll.`);
    },
  
    async click(threadId) {
      console.log(`[Thread ${threadId}] 🖱️ Trying random click...`);
      const anchors = document.querySelectorAll('a[href]');
      if (anchors.length > 0) {
        const randomAnchor = anchors[Math.floor(Math.random() * anchors.length)];
        randomAnchor.click();
      }
    },
  
    async moveMouse(threadId) {
      console.log(`[Thread ${threadId}] 🖱️ Moving mouse randomly...`);
      // Untuk simulate, bisa pake mouse events (optional advanced)
    }
  };
  